
#include <config.h>

#include <ctype.h>

#include <errno.h>

#include <sys/stat.h>

#include <hash.h>

#include <argp.h>

#include <argp-version-etc.h>

#include <progname.h>

#include <stdarg.h>

#include <version-etc.h>

#include <stdio.h>

#include <stdlib.h>

#include <unistd.h>

#include <string.h>

#include <getopt.h>

#include <obstack.h>

#include <error.h>

#include <xalloc.h>

#include <gettext.h>

#include <locale.h>

#define to_num(c) \
  (isdigit(c) ? c - '0' : (isxdigit(c) ? toupper(c) - 'A' + 10 : 255 ))

#define isws(c) ((c)==' '||(c)=='\t'||(c)=='\n')

#define isdelim(c,delim) (strchr(delim,(c))!=NULL)

#define CHAR_BIT 8

#define BITS_PER_WORD   (sizeof(unsigned)*CHAR_BIT)

#define WORDSIZE(n)     (((n) + BITS_PER_WORD - 1) / BITS_PER_WORD)

#define SETBIT(x, i)    ((x)[(i)/BITS_PER_WORD] |= (1<<((i) % BITS_PER_WORD)))

#define RESETBIT(x, i)  ((x)[(i)/BITS_PER_WORD] &= ~(1<<((i) % BITS_PER_WORD)))

#define BITISSET(x, i)  (((x)[(i)/BITS_PER_WORD] & (1<<((i) % BITS_PER_WORD))) != 0)

#define LOCAL_RC ".cflowrc"

#define MAXLEVELINDENT 216

#define LEVEL_BEGIN 1

#define LEVEL_INDENT0 2

#define LEVEL_INDENT1 3

#define LEVEL_END0 4

#define LEVEL_END1 5

#define SM_FUNCTIONS   0x0001

#define SM_DATA        0x0002

#define SM_STATIC      0x0004

#define SM_UNDERSCORE  0x0008

#define SM_TYPEDEF     0x0010

#define SM_UNDEFINED   0x0020

#define CHAR_TO_SM(c) ((c)=='x' ? SM_DATA : \
                        (c)=='_' ? SM_UNDERSCORE : \
                         (c)=='s' ? SM_STATIC : \
                          (c)=='t' ? SM_TYPEDEF : \
                           (c)=='u' ? SM_UNDEFINED : 0)

#define SYMBOL_INCLUDE(c) (symbol_map |= CHAR_TO_SM(c))

#define SYMBOL_EXCLUDE(c) (symbol_map &= ~CHAR_TO_SM(c))

#define _ARGCV_H 1

#define obstack_chunk_alloc xmalloc

#define obstack_chunk_free free

#define _(c) gettext(c)

#define N_(c) c

#define NUMITEMS(a) sizeof(a)/sizeof((a)[0])

#define PRINT_XREF 0x01

#define PRINT_TREE 0x02

#define CFLOW_PREPROC "/usr/bin/cpp"

#define MAX_OUTPUT_DRIVERS 8

#define INSTALL_DEFAULT     0x00

#define INSTALL_OVERWRITE   0x01

#define INSTALL_CHECK_LOCAL 0x02

#define INSTALL_UNIT_LOCAL  0x04

#define linked_list_head(list) ((list) ? (list)->head : NULL)

#define WORD 257

#define LBRACE0 258

#define RBRACE0 259

#define IDENTIFIER 260

#define EXTERN 261

#define STATIC 262

#define TYPEDEF 263

#define STRUCT 264

#define MODIFIER 265

#define OP 266

#define UNION 267

#define ENUM 268

#define LBRACE '{'

#define RBRACE '}'

#define MEMBER_OF 269

#define TYPE 270

#define STRING 271

#define PARM_WRAPPER 272

#define QUALIFIER 273
enum symbol_flag {symbol_none, symbol_temp, symbol_parm, symbol_alias};
enum storage {ExternStorage, ExplicitExternStorage, StaticStorage, AutoStorage, AnyStorage};
enum symtype {SymUndefined, SymToken, SymIdentifier};
enum option_code {OPT_DEFINES = 256, OPT_LEVEL_INDENT, OPT_DEBUG, OPT_PREPROCESS, OPT_NO_PREPROCESS, OPT_EMACS, OPT_NO_USE_INDENTATION, OPT_NO_ANSI, OPT_NO_TREE, OPT_NO_BRIEF, OPT_NO_EMACS, OPT_NO_VERBOSE, OPT_NO_NUMBER, OPT_NO_PRINT_LEVEL, OPT_NO_REVERSE, OPT_OMIT_ARGUMENTS, OPT_NO_OMIT_ARGUMENTS, OPT_OMIT_SYMBOL_NAMES, OPT_NO_OMIT_SYMBOL_NAMES};
typedef struct {
    char *str;
} YYSTYPE;
typedef struct {
    int type;
    char *token;
    int line;
} TOKSTK;
typedef struct {
    char *name;
    int type_end;
    int parmcnt;
    int line;
    enum storage storage;
} Ident;
typedef struct {
    int line;
    char *source;
} Ref;
struct symbol;
struct yy_trans_info;
struct yy_buffer_state;
struct table_entry;
struct output_symbol;
struct option_type;
struct cflow_depmap;
struct output_driver;
struct collect_data;
struct linked_list;
struct linked_list_entry;
typedef unsigned  char YY_CHAR;
typedef struct yy_buffer_state *YY_BUFFER_STATE;
typedef struct symbol Symbol;
typedef int flex_int32_t;
typedef short  int flex_int16_t;
typedef struct cflow_depmap *cflow_depmap_t;
typedef enum {cflow_output_init, cflow_output_begin, cflow_output_end, cflow_output_newline, cflow_output_separator, cflow_output_symbol, cflow_output_text} cflow_output_command;
typedef int yy_state_type;
typedef size_t yy_size_t;
typedef int Stackpos [1];
typedef void (*linked_list_free_data_fp) (void *);
typedef int temp_index;
extern int use_indentation;
extern int save_end;
extern int verbose;
extern int token_stack_increase;
extern int yy_did_buffer_switch_on_eof;
extern const flex_int32_t yy_meta [47];
extern const flex_int16_t yy_def [212];
extern const flex_int32_t yy_ec [256];
extern const flex_int16_t yy_chk [531];
extern int yyleng;
extern const flex_int16_t yy_base [212];
extern FILE *yyout;
extern int yy_start;
extern int yy_init;
extern YYSTYPE yylval;
extern TOKSTK tok;
extern char yy_hold_char;
extern char *yytext;
extern size_t yy_buffer_stack_max;
extern FILE *yyin;
extern YY_BUFFER_STATE *yy_buffer_stack;
extern int hit_eof;
extern int curs;
extern int tos;
extern struct obstack text_stk;
extern int token_stack_length;
extern TOKSTK *token_stack;
extern char *qualifiers [];
extern int yy_flex_debug;
extern int debug;
extern char quote_transtab [];
extern int driver_max;
extern int reverse_tree;
extern int record_defines;
extern char *keywords [];
extern Hash_table *symbol_table;
extern Symbol *caller;
extern const flex_int16_t yy_nxt [531];
extern int yy_n_chars;
extern char *level_begin;
extern char *level_end [];
extern char *level_indent [];
extern int level;
extern int level_mark_incr;
extern int level_mark_size;
extern unsigned  char *level_mark;
extern int strict_ansi;
extern struct obstack string_stk;
extern char *start_name;
extern char *outname;
extern char *canonical_filename;
extern char *filename;
extern int line_num;
extern const flex_int16_t yy_rule_linenum [81];
extern int yylineno;
extern FILE *outfile;
extern int out_line;
extern const char version_etc_copyright [];
extern int preprocess_option;
extern int omit_symbol_names_option;
extern int omit_arguments_option;
extern int emacs_option;
extern int max_depth;
extern int print_as_tree;
extern int print_levels;
extern int print_line_numbers;
extern const char *argp_program_bug_address;
extern struct obstack *opt_stack;
extern char *pp_opts;
extern char *pp_bin;
extern char *types [];
extern char *yy_last_accepting_cpos;
extern yy_state_type yy_last_accepting_state;
extern const flex_int16_t yy_accept [191];
extern char *yy_c_buf_p;
extern size_t yy_buffer_stack_top;
extern Stackpos start_pos;
extern int need_space;
extern int parm_level;
extern int driver_index;
extern int brief_listing;
extern int prev_token;
extern struct linked_list *static_func_list;
extern struct linked_list *auto_symbol_list;
extern struct linked_list *static_symbol_list;
extern char doc [];
extern unsigned  input_file_count;
extern struct linked_list *arglist;
extern int print_option;
extern struct argp argp;
extern int symbol_map;
extern const char *program_authors [];
void output ();
void set_level_mark1 (int lev, int mark);
void xref_output ();
size_t collect_symbols (Symbol * * * return_sym, int (* sel) (Symbol * p), size_t reserved_slots);
bool collect_processor1 (void * data, void * proc_data);
void xalloc_die (void);
int is_var1 (Symbol * symp);
int include_symbol (Symbol * sym);
int compare1 (const void * ap, const void * bp);
void print_function1 (Symbol * symp);
void print_refs (char * name, struct linked_list * reflist);
void print_type1 (Symbol * symp);
void tree_output1 ();
size_t collect_functions (Symbol * * * return_sym);
int symbol_is_function (Symbol * symp);
cflow_depmap_t depmap_alloc (size_t count);
void depmap_set (cflow_depmap_t dmap, size_t row, size_t col);
unsigned  *depmap_rowptr1 (cflow_depmap_t dmap, size_t row);
void depmap_tc (cflow_depmap_t dmap);
void transitive_closure1 (unsigned * R, int n);
int depmap_isset (cflow_depmap_t dmap, size_t row, size_t col);
void begin1 ();
void inverted_tree1 (int lev, int last, Symbol * sym);
int print_symbol1 (int direct, int level, int last, Symbol * sym);
void newline ();
void set_active1 (Symbol * sym);
int is_last1 (struct linked_list_entry * p);
int is_printable1 (struct linked_list_entry * p);
void clear_active1 (Symbol * sym);
void separator1 ();
Symbol *lookup (const char *name);
void direct_tree1 (int lev, int last, Symbol * sym);
void end1 ();
int register_output (const char * name, int (* handler) (cflow_output_command cmd, FILE * outfile, int line, void * data, void * handler_data), void * handler_data);
int gnu_output_handler (cflow_output_command cmd, FILE * outfile, int line, void * data, void * handler_data);
int print_symbol3 (FILE * outfile, int line, struct output_symbol * s);
void print_level (int lev, int last);
void print_function_name (Symbol * sym, int has_subtree);
int posix_output_handler (cflow_output_command cmd, FILE * outfile, int line, void * data, void * handler_data);
int print_symbol2 (FILE * outfile, int line, struct output_symbol * s);
void print_symbol_type1 (FILE * outfile, Symbol * sym);
int select_output_driver (const char * name);
void output_init ();
void sourcerc (int * argc_ptr, char * * * argv_ptr);
int argcv_get (const char * command, const char * delim, const char * cmnt, int * argc, char * * * argv);
int argcv_scan1 (int len, const char * command, const char * delim, const char * cmnt, int * start, int * end, int * save);
void argcv_unquote_copy (char * dst, const char * src, size_t n);
int xtonum1 (int * pval, const char * src, int base, int cnt);
int argcv_unquote_char (int c);
void expand_argcv1 (int * argc_ptr, char * * * argv_ptr, int argc, char * * argv);
void parse_rc (int * argc_ptr, char * * * argv_ptr, char * name);
void init ();
void init_lex (int debug_level);
void init_tokens ();
Symbol *install (char *name, int flags);
void append_symbol1 (struct linked_list * * plist, Symbol * sp);
void linked_list_unlink (struct linked_list * list, struct linked_list_entry * ent);
int data_in_list (void * data, struct linked_list * list);
void linked_list_append (struct linked_list * * plist, void * data);
struct linked_list *deref_linked_list1 (struct linked_list **plist);
size_t hash_symbol_hasher1 (void const * data, unsigned n_buckets);
bool hash_symbol_compare1 (void const * data1, void const * data2);
void init_parse ();
void clearstack ();
void pp_option (const char * arg);
int source (char * name);
FILE *pp_open (const char *name);
void pp_finalize ();
void yyrestart (FILE * input_file);
void yyensure_buffer_stack1 (void);
void *yyalloc (yy_size_t size);
void yy_fatal_error (const char * msg);
void *yyrealloc (void *ptr, yy_size_t size);
YY_BUFFER_STATE yy_create_buffer (FILE * file, int size);
void yy_init_buffer1 (YY_BUFFER_STATE b, FILE * file);
void yy_flush_buffer (YY_BUFFER_STATE b);
void yy_load_buffer_state1 (void);
int yyparse ();
int nexttoken ();
int get_token ();
int yylex ();
void yy_fatal_error (const char * msg);
YY_BUFFER_STATE yy_create_buffer (FILE * file, int size);
void yy_init_buffer1 (YY_BUFFER_STATE b, FILE * file);
void update_loc ();
int ident ();
yy_state_type yy_get_previous_state1 (void);
yy_state_type yy_try_NUL_trans1 (yy_state_type yy_current_state);
int yy_get_next_buffer1 (void);
int source (char * name);
void yyrestart (FILE * input_file);
int yywrap ();
void pp_close (FILE * fp);
void delete_statics ();
void static_free1 (void * data);
void delete_symbol1 (Symbol * sym);
void unlink_symbol1 (Symbol * sym);
void linked_list_destroy (struct linked_list * * plist);
int symbol_is_function (Symbol * symp);
void linked_list_append (struct linked_list * * plist, void * data);
void tokpush (int type, int line, char * token);
void parse_typedef ();
int fake_struct (Ident * ident);
void mark (Stackpos pos);
int putback ();
void skip_struct ();
int skip_balanced (int open_tok, int close_tok, int level);
void file_error1 (char * msg, TOKSTK * tokptr);
void print_token1 (TOKSTK * tokptr);
void restore (Stackpos pos);
int dcl (Ident * idptr);
int dirdcl (Ident * idptr);
void skip_to (int c);
void maybe_parm_list (int * parm_cnt_return);
void parse_declaration (Ident * ident, int parm);
int is_function1 ();
void parse_function_declaration (Ident * ident, int parm);
void parse_knr_dcl (Ident * ident);
void parse_dcl (Ident * ident, int maybe_knr);
void save_stack ();
void declare (Ident * ident, int maybe_knr);
void undo_save_stack ();
Symbol *install_ident (char *name, enum storage storage);
void append_symbol1 (struct linked_list * * plist, Symbol * sp);
void linked_list_unlink (struct linked_list * list, struct linked_list_entry * ent);
int data_in_list (void * data, struct linked_list * list);
size_t hash_symbol_hasher1 (void const * data, unsigned n_buckets);
bool hash_symbol_compare1 (void const * data1, void const * data2);
void ident_change_storage (Symbol * sp, enum storage storage);
int get_knr_args (Ident * ident);
Symbol *get_symbol (char *name);
char *finish_save_stack (char *name);
void save_token (TOKSTK * tokptr);
void func_body ();
void move_parms (int level);
void cleanup_stack ();
void expression ();
void call (char * name, int line);
Symbol *add_reference (char *name, int line);
int globals_only ();
struct linked_list *linked_list_create (linked_list_free_data_fp fun);
void reference (char * name, int line);
void parse_variable_declaration (Ident * ident, int parm);
void initializer_list ();
void delete_autos (int level);
void linked_list_iterate (struct linked_list * * plist, int (* itr) (void *, void *), void * data);
int delete_level_autos (void * data, void * call_data);
int delete_level_statics (void * data, void * call_data);
void delete_parms (int level);
int delete_parms_itr (void * data, void * call_data);
void declare_type (Ident * ident);
error_t parse_opt1 (int key, char * arg, struct argp_state * state);
void set_print_option1 (char * str);
int find_option_type1 (struct option_type * optype, const char * str, int len);
void set_level_indent1 (const char * str);
void parse_level_string1 (const char * str, char * * return_ptr);
int number1 (const char * * str_ptr, int base, int count);
int select_output_driver (const char * name);
void symbol_override1 (const char * str);
void append_symbol1 (struct linked_list * * plist, Symbol * sp);
void linked_list_unlink (struct linked_list * list, struct linked_list_entry * ent);
int data_in_list (void * data, struct linked_list * list);
void linked_list_append (struct linked_list * * plist, void * data);
size_t hash_symbol_hasher1 (void const * data, unsigned n_buckets);
bool hash_symbol_compare1 (void const * data1, void const * data2);
void set_preprocessor (const char * arg);
void add_name1 (const char * name);
void add_preproc_option1 (int key, const char * arg);
void GRAFT_INTERFACE (char * $_host_filename, int $_host_length, char * * $_host_params);
