#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <check.h>


int compare_two_binary_files(FILE *fp1, FILE *fp2) {
    char ch1, ch2;
    int flag = 0;
    while (((ch1 = fgetc(fp1)) != EOF) &&((ch2 = fgetc(fp2)) != EOF)) {
        if (ch1 == ch2) {
            flag = 1;
            continue;
        } else {
            fseek(fp1, -1, SEEK_CUR);
            flag = 0;
            break;
        }
    }
    if (ch1 == EOF) {
        ch2 = fgetc(fp2);
    }

    if ((ch1 != EOF) || (ch2 != EOF)) {
        flag = 0;
    }

    if (flag == 0) {
        return 1;
        //printf("Two files are not equal :  byte poistion at which two files differ is %d\n", ftell(fp1) + 1);

    } else {
        return 0;
        //printf("Two files are Equal\n ", ftell(fp1) + 1);
    }

}

START_TEST(test_1) {

	char * commandRemove = "rm -f testCandidate.out";


    char * commandCandidate = "./Individual.x -o testCandidate.out argcv.c";
    char * commandOracle = "cflow -o oracleResult.out argcv.c";

	system(commandRemove);

    system(commandCandidate);
    system(commandOracle);


    FILE * candidateFile = fopen("testCandidate.out", "r");
    FILE * oracleFile = fopen("oracleResult.out", "r");

    char * line = (char *) malloc(1000 * sizeof (char));
    
    if(compare_two_binary_files(candidateFile, oracleFile)){
       ck_abort();
    }

}

END_TEST



START_TEST(test_2) {


	char * commandRemove = "rm -r testCandidate2.out";


    char * commandCandidate = "./Individual.x -r -o testCandidate2.out argcv.c";
    char * commandOracle = "cflow -r -o oracleResult2.out argcv.c";

	system(commandRemove);

    system(commandCandidate);
    system(commandOracle);

    FILE * candidateFile = fopen("testCandidate2.out", "r");
    FILE * oracleFile = fopen("oracleResult2.out", "r");


    if (compare_two_binary_files(candidateFile, oracleFile)) {
        ck_abort();
    }

}

END_TEST




START_TEST(test_3) {


	char * commandRemove = "rm -f testCandidate3.out";


    char * commandCandidate = "./Individual.x -r -o testCandidate3.out -T argcv.c";
    char * commandOracle = "cflow -r -o oracleResult3.out  -T argcv.c";


	system(commandRemove);

    system(commandCandidate);
    system(commandOracle);

    FILE * candidateFile = fopen("testCandidate3.out", "r");
    FILE * oracleFile = fopen("oracleResult3.out", "r");


    if (compare_two_binary_files(candidateFile, oracleFile)) {
        ck_abort();
    }

}

END_TEST


START_TEST(test_4) {

	char * commandRemove = "rm -f testCandidate4.out";


    char * commandCandidate = "./Individual.x -o testCandidate4.out  main.c output.c";
    char * commandOracle = "cflow -o oracleResult4.out main.c output.c";

	system(commandRemove);

    system(commandCandidate);
    system(commandOracle);


    FILE * candidateFile = fopen("testCandidate4.out", "r");
    FILE * oracleFile = fopen("oracleResult4.out", "r");

    char * line = (char *) malloc(1000 * sizeof (char));
    
    if(compare_two_binary_files(candidateFile, oracleFile)){
       ck_abort();
    }

}

END_TEST



Suite *
money_suite(void) {

    Suite *s = suite_create("GenTransSuite");
    // Core test case 
    TCase *tc_core = tcase_create("Core");
    tcase_set_timeout(tc_core, 3);
    tcase_add_test(tc_core, test_1);
    tcase_add_test(tc_core, test_2);
    tcase_add_test(tc_core, test_3);
    tcase_add_test(tc_core, test_4);
    suite_add_tcase(s, tc_core);
    return s;

}

int main(int argc, char** argv) {



    int number_failed;
    Suite *s = money_suite();
    SRunner *sr = srunner_create(s);

    srunner_run_all(sr, CK_NORMAL);

    number_failed = srunner_ntests_failed(sr);
    srunner_free(sr);
    return (number_failed == 0) ? EXIT_SUCCESS : EXIT_FAILURE;
    //  return (EXIT_SUCCESS);
}
